package Linode::Longview::DataGetter::Network;

use Exporter;
@ISA       = qw(Exporter);
@EXPORT_OK = qw(get);

use Linode::Longview::Util qw(slurp_file $procfs);

sub get {
	my (undef, $dataref) = @_;
	my @data = ( slurp_file( $procfs . 'net/dev' ) )
		or die "Couldn't read ${procfs}net/dev: $!";

	foreach my $line (@data) {
		next unless $line =~ /^\s*.*?:/;
		$line =~ s/^\s*//;
		my ( $dev, $rx_bytes, $tx_bytes )
			= ( split( /\s+/, $line ) )[ 0, 1, 9 ];
		next if ( $rx_bytes == 0 && $tx_bytes == 0 );
		$dev =~ s/:$//;

		# We need to "numify" these matches to make JSON::PP not-quote
		$dataref->{LONGTERM}->{"Network.Interface.$dev.rx_bytes"} = $rx_bytes + 0;
		$dataref->{LONGTERM}->{"Network.Interface.$dev.tx_bytes"} = $tx_bytes + 0;
	}
	return $dataref;
}

1;

