package Linode::Longview::DataGetter::Packages::APT;

use Linux::APT;
use feature 'state';

use Exporter 'import';
our @EXPORT_OK = ('get');

sub get {
	my ( undef, $dataref ) = @_;
	my $apt = Linux::APT->new();
	$apt->update if shouldUpdate();
	my $pkgs = $apt->toupgrade()->{packages};
	$dataref->{INSTANT}->{Packages} = [
		map {
			{   name    => $_,
				current => $pkgs->{$_}{current},
				new     => $pkgs->{$_}{new} }
		} keys %$pkgs
	];
	return $dataref;
}

sub shouldUpdate {
	state $nextRun;
	return 0 if((defined $nextRun) && ($nextRun > time));
	$nextRun = time + 86400; #Only actually hit the mirrors once every 24 hours.
	return 1;
}

1;
