package Linode::Longview::DataGetter::Packages::YUM;

use Exporter 'import';
our @EXPORT_OK = (qw(get));

sub get {
	my (undef, $dataref) = @_;
	my %uPkgs = upgradablePkgs();
	if (!%uPkgs){
		$dataref->{INSTANT}->{Packages} = [];
		return $dataref;
	}
	my %cPkgs = currentPkgs();
	$dataref->{INSTANT}->{Packages} = [
		map { 
			{
				name => $_,
				current => $cPkgs{$_},
				new => $uPkgs{$_}
			} 
		}
		keys %uPkgs
	];
	return $dataref;
}

sub currentPkgs {

	# yum wraps unless we fake tty
	my @pkgList = qx(script -c "yum --color=never list installed" /dev/null);
	my %pkgs;
	foreach my $pkg (@pkgList) {
		if ( $pkg =~ m/^(.*?)\s+(.*?)\s+@(.*)$/ ) {
			$pkgs{$1} = $2;
		}
	}
	return %pkgs;
}

sub upgradablePkgs {
	my @pkgList = qx(yum check-update);
	my %pkgs;
	foreach my $pkg (@pkgList) {
		if ( $pkg =~ m/^(\S+)\s+(\S+)\s+\S+$/ ) {
			$pkgs{$1} = $2;
		}
	}
	return %pkgs;
}

1;
